Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.web.servlet.view
Class AbstractTemplateView

    java.lang.Object
      org.springframework.context.support.ApplicationObjectSupport
          org.springframework.web.context.support.WebApplicationObjectSupport
              org.springframework.web.servlet.view.AbstractView
                  org.springframework.web.servlet.view.AbstractUrlBasedView
                      org.springframework.web.servlet.view.AbstractTemplateView

All Implemented Interfaces:
  Aware, BeanNameAware, InitializingBean, ApplicationContextAware, ServletContextAware, View

Direct Known Subclasses:
  FreeMarkerView, VelocityView

    public abstract class AbstractTemplateView

extends AbstractUrlBasedView

Adapter base class for template-based view technologies such as Velocity and FreeMarker, with the ability to use request and session attributes in their model and the option to expose helper objects for Spring's Velocity/FreeMarker macro library.

JSP/JSTL and other view technologies automatically have access to the HttpServletRequest object and thereby the request/session attributes for the current user. Furthermore, they are able to create and cache helper objects as request attributes themselves.

Since:
  1.0.2
Author:
  Juergen Hoeller, Darren Davison
See Also:
  `AbstractTemplateViewResolver`, `VelocityView`, `FreeMarkerView`

Field Summary
`static java.lang.String` | `SPRING_MACRO_REQUEST_CONTEXT_ATTRIBUTE` Variable name of the RequestContext instance in the template model, available to Spring's macros: e.g.

Fields inherited from class org.springframework.web.servlet.view.AbstractView
`DEFAULT_CONTENT_TYPE`

Fields inherited from class org.springframework.context.support.ApplicationObjectSupport
`logger`

Fields inherited from interface org.springframework.web.servlet.View
`PATH_VARIABLES, RESPONSE_STATUS_ATTRIBUTE`

Constructor Summary
`AbstractTemplateView()`

Method Summary
`protected void` | `applyContentType(javax.servlet.http.HttpServletResponse response)` Apply this view's content type as specified in the "contentType" bean property to the given response.
`protected void` | `renderMergedOutputModel(java.util.Map<java.lang.String,java.lang.Object> model, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)` Subclasses must implement this method to actually render the view.
`protected abstract void` | `renderMergedTemplateModel(java.util.Map<java.lang.String,java.lang.Object> model, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)` Subclasses must implement this method to actually render the view.
`void` | `setAllowRequestOverride(boolean allowRequestOverride)` Set whether HttpServletRequest attributes are allowed to override (hide) controller generated model attributes of the same name.
`void` | `setAllowSessionOverride(boolean allowSessionOverride)` Set whether HttpSession attributes are allowed to override (hide) controller generated model attributes of the same name.
`void` | `setExposeRequestAttributes(boolean exposeRequestAttributes)` Set whether all request attributes should be added to the model prior to merging with the template.
`void` | `setExposeSessionAttributes(boolean exposeSessionAttributes)` Set whether all HttpSession attributes should be added to the model prior to merging with the template.
`void` | `setExposeSpringMacroHelpers(boolean exposeSpringMacroHelpers)` Set whether to expose a RequestContext for use by Spring's macro library, under the name "springMacroRequestContext".

Methods inherited from class org.springframework.web.servlet.view.AbstractUrlBasedView
`afterPropertiesSet, checkResource, getUrl, isUrlRequired, setUrl, toString`

Methods inherited from class org.springframework.web.servlet.view.AbstractView
`addStaticAttribute, createMergedOutputModel, createRequestContext, createTemporaryOutputStream, exposeModelAsRequestAttributes, generatesDownloadContent, getAttributesMap, getBeanName, getContentType, getRequestContextAttribute, getStaticAttributes, isExposePathVariables, prepareResponse, render, setAttributes, setAttributesCSV, setAttributesMap, setBeanName, setContentType, setExposePathVariables, setRequestContextAttribute, writeToResponse`

Methods inherited from class org.springframework.web.context.support.WebApplicationObjectSupport
`getServletContext, getTempDir, getWebApplicationContext, initApplicationContext, initServletContext, isContextRequired, setServletContext`

Methods inherited from class org.springframework.context.support.ApplicationObjectSupport
`getApplicationContext, getMessageSourceAccessor, initApplicationContext, requiredContextClass, setApplicationContext`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### SPRING_MACRO_REQUEST_CONTEXT_ATTRIBUTE

    public static final java.lang.String SPRING_MACRO_REQUEST_CONTEXT_ATTRIBUTE

  Variable name of the RequestContext instance in the template model, available to Spring's macros: e.g. for creating BindStatus objects.

  See Also:
    Constant Field Values

Constructor Detail

### AbstractTemplateView

    public AbstractTemplateView()

Method Detail

### setExposeRequestAttributes

    public void setExposeRequestAttributes(boolean exposeRequestAttributes)

  Set whether all request attributes should be added to the model prior to merging with the template. Default is "false".

### setAllowRequestOverride

    public void setAllowRequestOverride(boolean allowRequestOverride)

  Set whether HttpServletRequest attributes are allowed to override (hide) controller generated model attributes of the same name. Default is "false", which causes an exception to be thrown if request attributes of the same name as model attributes are found.

### setExposeSessionAttributes

    public void setExposeSessionAttributes(boolean exposeSessionAttributes)

  Set whether all HttpSession attributes should be added to the model prior to merging with the template. Default is "false".

### setAllowSessionOverride

    public void setAllowSessionOverride(boolean allowSessionOverride)

  Set whether HttpSession attributes are allowed to override (hide) controller generated model attributes of the same name. Default is "false", which causes an exception to be thrown if session attributes of the same name as model attributes are found.

### setExposeSpringMacroHelpers

    public void setExposeSpringMacroHelpers(boolean exposeSpringMacroHelpers)

  Set whether to expose a RequestContext for use by Spring's macro library, under the name "springMacroRequestContext". Default is "true".

  Currently needed for Spring's Velocity and FreeMarker default macros. Note that this is not required for templates that use HTML forms unless you wish to take advantage of the Spring helper macros.

  See Also:
    `SPRING_MACRO_REQUEST_CONTEXT_ATTRIBUTE`

### renderMergedOutputModel

    protected final void renderMergedOutputModel(java.util.Map<java.lang.String,java.lang.Object> model,
                                                 javax.servlet.http.HttpServletRequest request,
                                                 javax.servlet.http.HttpServletResponse response)
                                          throws java.lang.Exception

  Description copied from class: `AbstractView`
  Subclasses must implement this method to actually render the view.

  The first step will be preparing the request: In the JSP case, this would mean setting model objects as request attributes. The second step will be the actual rendering of the view, for example including the JSP via a RequestDispatcher.

  Specified by:
    `renderMergedOutputModel` in class `AbstractView`
  Parameters:
    `model` - combined output Map (never `null`), with dynamic values taking precedence over static attributes
    `request` - current HTTP request
    `response` - current HTTP response
  Throws:
    `java.lang.Exception` - if rendering failed

### applyContentType

    protected void applyContentType(javax.servlet.http.HttpServletResponse response)

  Apply this view's content type as specified in the "contentType" bean property to the given response.

  When running on Servlet 2.4, only applies the view's contentType if no content type has been set on the response before. This allows handlers to override the default content type beforehand.

  Parameters:
    `response` - current HTTP response
  See Also:
    `AbstractView.setContentType(java.lang.String)`

### renderMergedTemplateModel

    protected abstract void renderMergedTemplateModel(java.util.Map<java.lang.String,java.lang.Object> model,
                                                      javax.servlet.http.HttpServletRequest request,
                                                      javax.servlet.http.HttpServletResponse response)
                                               throws java.lang.Exception

  Subclasses must implement this method to actually render the view.

  Parameters:
    `model` - combined output Map, with request attributes and session attributes merged into it if required
    `request` - current HTTP request
    `response` - current HTTP response
  Throws:
    `java.lang.Exception` - if rendering failed

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD